unit UnitDynamicHissanSeki0557;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,printers, HissanSeki{HissanSeki.pas}, Grids, Spin;

type
  TFormDynamicHissanSeki0557 = class(TForm)
    ButtonPrintOut: TButton;
    ButtonPrinterSetup: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    LabelGappiNamae: TLabel;
    LabelProjectName: TLabel;
    GroupBoxStart: TGroupBox;
    CheckBoxRuledLine: TCheckBox;
    CheckBoxPrintAnswer: TCheckBox;
    StringGrid1: TStringGrid;
    ButtonKoushin: TButton;
    LabelFontSize: TLabel;
    SpinEditFontSize: TSpinEdit;
    LabelHyoudai: TLabel;
    RadioGroupDangumi: TRadioGroup;
    ButtonRadioGroupBoxStartClose: TButton;
    ButtonStart: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonPrintOutClick(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure ButtonPrinterSetupClick(Sender: TObject);
    procedure CheckBoxRuledLineClick(Sender: TObject);
    procedure Sakujo(Sender: TObject);
    procedure Sakusei(Sender: TObject);
    procedure ButtonKoushinClick(Sender: TObject);
    procedure SpinEditFontSizeChange(Sender: TObject);
    procedure DangumiKakidashi(Sender: TObject);
    procedure CreateComponent(y, t, ALeft, ATop, AWidth, AHeight: Integer; SRL,SA:boolean);
     //y:R|[lgɉԂ, t:cɉԂ, ALeft:LeftW, ATop:TopW, AWidth:, AHeight:,SRL:ʎ̘g\̗L,SA:𓚒l̗̈L
    procedure ButtonRadioGroupBoxStartCloseClick(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure CheckBoxPrintAnswerClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormDynamicHissanSeki0557: TFormDynamicHissanSeki0557;

var
  s1_100,s1_10,s1_1,
  s2_100,s2_10,s2_1: integer;
  tate, yoko: integer;
  dx, dy: word;
  ShowAnswer: boolean;//𓚂邩ǂBtrue:B
  ShwoRuledLine: boolean;//ʎ̘g\̗L true:B
implementation

{$R *.DFM}

procedure TFormDynamicHissanSeki0557.FormCreate(Sender: TObject);
var i:integer;
begin
  ButtonStart.Hide;
  SpinEditFontSize.Hide;
  LabelFontSize.Hide;

  Color:= clWhite;
  BorderStyle:= bsSizeable;
  PrintScale:= poPrintToFit;
  Scaled:= True;
  tate:=2;
  yoko:=4;

  StringGrid1.ColWidths[0]:=18;
  StringGrid1.Cells[0,1]:='';
  StringGrid1.Cells[0,2]:='';
  StringGrid1.Cells[0,3]:='';
  StringGrid1.colCount:= tate*yoko+1;
  StringGrid1.RowCount:= 4;
  for i:=1 to 30 do
    StringGrid1.Cells[i,0]:=inttostr(i);

  RadioGroupDangumi.ItemIndex:=0;
  DangumiKakidashi(Sender);
  Sakusei(Sender);
  LabelProjectName.caption:= Self.Caption;
end;

procedure TFormDynamicHissanSeki0557.FormDblClick(Sender: TObject);
begin
  Sakujo(Sender);
  DangumiKakidashi(Sender);
  Sakusei(Sender);
end;

procedure TFormDynamicHissanSeki0557.ButtonPrinterSetupClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFormDynamicHissanSeki0557.ButtonPrintOutClick(Sender: TObject);
begin
  ButtonPrintOut.Hide;
  ButtonPrinterSetup.Hide;
  ButtonKoushin.Hide;
  GroupBoxStart.Hide;

  printer.Orientation:= poLandscape;//v^ZbgAbv_CAOʂAڂɉuɐݒ

  sakujo(sender);
  ShowAnswer:=false;
  sakusei(sender);
  Printer.Title:=self.Text+'𓚒lȂ';
  Self.Print;

  if CheckBoxPrintAnswer.Checked=true then
  begin
    sakujo(sender);
    ShowAnswer:= true;
    Sakusei(sender);
    Printer.Title:=self.Text+'𓚒l';
    Self.Print;
    ShowAnswer:=false;
  end;

  FormDblClick(Sender);

  GroupBoxStart.Show;

  ButtonPrinterSetup.Show;
  ButtonPrintOut.Show;
  ButtonKoushin.show;
end;

procedure TFormDynamicHissanSeki0557.CheckBoxRuledLineClick(Sender: TObject);
begin
  sakujo(sender);
  DangumiKakidashi(Sender);
  Sakusei(sender);
end;

procedure TFormDynamicHissanSeki0557.Sakujo(Sender: TObject);
var
  DynHissanSeki: Tcomponent;
  ComponentName: string;
  i,j: integer;
begin
  for j:=1 to tate do
    for i:= 1 to yoko do
    begin
      ComponentName:= 'DynHissanSeki'+ IntToStr(i+yoko*(j-1));
      DynHissanSeki := FindComponent(ComponentName);  { IɐR|[lgT }
      if DynHissanSeki <> nil then DynHissanSeki.Free;   { R|[lgꍇinil łȂꍇjAR|[lg }
  end;
end;

procedure TFormDynamicHissanSeki0557.Sakusei(Sender: TObject);
var  i,j,k: integer;
     n1,n2:integer;
begin
  k:=1;//stringgridrowԍ
  for j:= 1 to tate do
    for i:= 1 to yoko do
    begin
// s1_100,s1_10,s1_1  strtoint(StringGrid1.Cells[1,k]) ;
      n1:=strtoint(StringGrid1.Cells[k,1]);
      case n1 of
        100..999:begin
                   s1_100:= strtoint(copy(inttostr(n1),1,1));
                   s1_10:=  strtoint(copy(inttostr(n1),2,1));
                   s1_1:=   strtoint(copy(inttostr(n1),3,1));
                 end;
         10.. 99:begin
                   s1_100:= 0;
                   s1_10:=  strtoint(copy(inttostr(n1),1,1));
                   s1_1:=   strtoint(copy(inttostr(n1),2,1));
                 end;
          1..  9:begin
                   s1_100:= 0;
                   s1_10:=  0;
                   s1_1:=   strtoint(copy(inttostr(n1),1,1));
                 end;
      end;
// s2_100,s2_10,s2_1  strtoint(StringGrid1.Cells[k,2]) ;
      n2:=strtoint(StringGrid1.Cells[k,2]);
      case n2 of
        100..999:begin
                   s2_100:= strtoint(copy(inttostr(n2),1,1));
                   s2_10:=  strtoint(copy(inttostr(n2),2,1));
                   s2_1:=   strtoint(copy(inttostr(n2),3,1));
                 end;
         10.. 99:begin
                   s2_100:= 0;
                   s2_10:=  strtoint(copy(inttostr(n2),1,1));
                   s2_1:=   strtoint(copy(inttostr(n2),2,1));
                 end;
          1..  9:begin
                   s2_100:= 0;
                   s2_10:=  0;
                   s2_1:=   strtoint(copy(inttostr(n2),1,1));
                 end;
      end;
      dx:= ((self.Width-32) div yoko); //form̕1036
      dy:= ((self.Height-48) div tate); //form̍766
      CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
      k:=k+1;
    end;
end;

procedure TFormDynamicHissanSeki0557.ButtonKoushinClick(Sender: TObject);
begin
  Sakujo(sender);
  DangumiKakidashi(Sender);
  Sakusei(sender);
end;

procedure TFormDynamicHissanSeki0557.SpinEditFontSizeChange(Sender: TObject);
begin
  Sakujo(sender);
  Sakusei(sender);
end;

procedure TFormDynamicHissanSeki0557.DangumiKakidashi(Sender: TObject);
var i,j,k: integer;
begin
  StringGrid1.colCount:= tate*yoko+1;
  case RadioGroupDangumi.ItemIndex of
    0:begin // HHH~HHHASQi
        LabelHyoudai.Caption:='HHH~HHH';
        sakujo(sender);
        yoko:=4;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=random( 9)+1;//  1<= |鐔̕S̈ <=9
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    1:begin // HHH~HHOASQi
        LabelHyoudai.Caption:='HHH~HHO';
        sakujo(sender);
        yoko:=4;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=random( 9)+1;//  1<= |鐔̕S̈ <=9
            s2_1:=             0;//      |鐔̈̈      =0
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    2:begin // HHH~HOHASQi
        LabelHyoudai.Caption:='HHH~HOH';
        sakujo(sender);
        yoko:=4;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=random( 9)+1;//  1<= |鐔̕S̈ <=9
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:=            0;//      |鐔̏\̈      =0
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    3:begin// HHH~HOOASSi
        LabelHyoudai.Caption:='HHH~HOO';
        sakujo(sender);
        yoko:=4;tate:=4;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=random( 9)+1;//  1<= |鐔̕S̈ <=9
            s2_1:=             0;//      |鐔̈̈      =0
            s2_10:=            0;//      |鐔̏\̈      =0
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    4:begin// HHH~@HHASQi
        LabelHyoudai.Caption:='HHH~@HH';
        sakujo(sender);
        yoko:=4;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=random( 9)+1;//  1<= |鐔̕S̈ <=9
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=           0;//      |鐔̕S̈      =0
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    5:begin// HHH~@HOATSi
        LabelHyoudai.Caption:='HHH~@HO';
        sakujo(sender);
        yoko:=5;tate:=4;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=random( 9)+1;//  1<= |鐔̕S̈ <=9
            s2_1:=             0;//      |鐔̈̈      =0
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=           0;//      |鐔̕S̈      =0
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    6:begin// HHH~@@HATSi
        LabelHyoudai.Caption:='HHH~@@H';
        sakujo(sender);
        yoko:=5;tate:=4;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=random( 9)+1;//  1<= |鐔̕S̈ <=9
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:=            0;//      |鐔̏\̈      =0
            s2_100:=           0;//      |鐔̕S̈      =0
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    7:begin// @HH~HHHATQi
        LabelHyoudai.Caption:='@HH~HHH';
        sakujo(sender);
        yoko:=5;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    8:begin// @HH~HHOATQi
        LabelHyoudai.Caption:='@HH~HHO';
        sakujo(sender);
        yoko:=5;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=             0;//      |鐔̈̈      =0
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
    9:begin// @HH~HOHATQi
        LabelHyoudai.Caption:='@HH~HOH';
        sakujo(sender);
        yoko:=5;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:=            0;//      |鐔̏\̈      =0
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
   10:begin// @HH~HOOATSi
        LabelHyoudai.Caption:='@HH~HOO';
        sakujo(sender);
        yoko:=5;tate:=4;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=             0;//      |鐔̈̈      =0
            s2_10:=            0;//      |鐔̏\̈      =0
            s2_100:=random( 9)+1;//  1<= |鐔̕S̈     <=9
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
   11:begin// @HH~HHAUSi
        LabelHyoudai.Caption:='@HH~@HH';
        sakujo(sender);
        yoko:=6;tate:=2;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=           0;//      |鐔̕S̈      =0
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
   12:begin// @HH~HOAUSi
        LabelHyoudai.Caption:='@HH~@HO';
        sakujo(sender);
        yoko:=6;tate:=4;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=             0;//      |鐔̈̈      =0
            s2_10:= random( 9)+1;//  1<= |鐔̏\̈     <=9
            s2_100:=           0;//      |鐔̕S̈      =0
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
   13:begin// @HH~@HAUSi
        LabelHyoudai.Caption:='@HH~@@H';
        sakujo(sender);
        yoko:=6;tate:=4;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:= random( 9)+1;//  1<= |鐔̏\̈ <=9
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:=            0;//      |鐔̏\̈      =0
            s2_100:=           0;//      |鐔̕S̈      =0
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
   14:begin// @@H~@HAVSi
        LabelHyoudai.Caption:='@@H~@@H';
        sakujo(sender);
        yoko:=7;tate:=4;
        dx:= ((self.Width-32) div yoko); //form̕1036
        dy:= ((self.Height-48) div tate); //form̍766
        StringGrid1.colCount:= tate*yoko+1;
        randomize;
        k:=1;//stringgridcolԍ
        for j:= 1 to tate do
        begin
          for i:= 1 to yoko do
          begin
            s1_1:=  random( 9)+1;//  1<= |鐔̈̈ <=9
            s1_10:=            0;//      |鐔̏\̈  =0
            s1_100:=           0;//      |鐔̕S̈  =0
            s2_1:=  random( 9)+1;//  1<= |鐔̈̈     <=9
            s2_10:=            0;//      |鐔̏\̈      =0
            s2_100:=           0;//      |鐔̕S̈      =0
            StringGrid1.Cells[k,1]:= inttostr(s1_100*100+s1_10*10+s1_1);
            StringGrid1.Cells[k,2]:= inttostr(s2_100*100+s2_10*10+s2_1);
            StringGrid1.Cells[k,3]:= inttostr((s1_100*100+s1_10*10+s1_1)*(s2_100*100+s2_10*10+s2_1));
            CreateComponent(i,j,32+dx*(i-1), 48+dy*(j-1),148, 139,CheckBoxRuledLine.Checked,ShowAnswer);
            k:=k+1;
          end;
        end;
      end;
  end;
end;

procedure TFormDynamicHissanSeki0557.CreateComponent(y, t, ALeft, ATop, AWidth, AHeight: Integer; SRL,SA:boolean);
     //y:R|[lgɉԂ, t:cɉԂ, ALeft:LeftW, ATop:TopW, AWidth:, AHeight:,SRL:ʎ̘g\̗L,SA:𓚒l̗̈L
var  DynHissanSeki:  THissanSeki;
     ComponentName: string;
begin
  ComponentName:= 'DynHissanSeki'+ IntToStr(y+yoko*(t-1));
  if FindComponent(ComponentName) <> nil then Exit;  { łɃR|[lg𐶐Ăꍇ́AȂ }
  DynHissanSeki := THissanSeki.Create(Self);
  DynHissanSeki.SetBounds(ALeft, ATop, AWidth, AHeight);  { ʒu(LeftCTop)Ƒ傫(WidthCHeight)w肷 }
  DynHissanSeki.Parent := Self;              { eR|[lgw肷 }
  DynHissanSeki.Name := ComponentName;                 { R|[lgw肷 }
  DynHissanSeki.FontSize:=SpinEditFontSize.Value;  //tHgTCY
  DynHissanSeki.VL1_1:=  s1_1;
  DynHissanSeki.VL1_10:= s1_10;
  DynHissanSeki.VL1_100:=s1_100;
  DynHissanSeki.VL2_1:=  s2_1;
  DynHissanSeki.VL2_10:= s2_10;
  DynHissanSeki.VL2_100:=s2_100;
  DynHissanSeki.ShowRuledLine:=SRL;
  DynHissanSeki.ShowAnswer:=SA;
  DynHissanSeki.Hint:= DynHissanSeki.Name;
  DynHissanSeki.ShowHint:= true;
end;

procedure TFormDynamicHissanSeki0557.ButtonRadioGroupBoxStartCloseClick(Sender: TObject);
begin
  GroupBoxStart.Hide;
  ButtonStart.Show;
end;

procedure TFormDynamicHissanSeki0557.ButtonStartClick(Sender: TObject);
begin
  ButtonStart.Hide;
  GroupBoxStart.Show;
end;

procedure TFormDynamicHissanSeki0557.CheckBoxPrintAnswerClick(Sender: TObject);
begin
  if CheckBoxPrintAnswer.Checked=true then ShowAnswer:= true
  else ShowAnswer:= false;
end;

end.
